import { ILayer, ILngLat, ITile } from '@antv/l7-core';
import { SourceTile } from '@antv/l7-utils';
export default abstract class Tile implements ITile {
    x: number;
    y: number;
    z: number;
    key: string;
    protected parent: ILayer;
    sourceTile: SourceTile;
    visible: boolean;
    protected layers: ILayer[];
    isLoaded: boolean;
    constructor(sourceTile: SourceTile, parent: ILayer);
    getLayers(): ILayer[];
    styleUpdate(...arg: any): void;
    abstract initTileLayer(): Promise<void>;
    lnglatInBounds(lnglat: ILngLat): boolean;
    protected addMask(layer: ILayer, mask: ILayer): Promise<void>;
    protected addLayer(layer: ILayer): Promise<void>;
    updateVisible(value: boolean): void;
    updateOptions(key: string, value: any): void;
    destroy(): void;
}
